<%@page buffer="none" session="false" taglibs="c,cms,fmt,fn" trimDirectiveWhitespaces="true"%>
<%@include file="../elements/glide-methods.jsp"%>

<cms:formatter var="content">

<c:choose>
    <c:when test="${cms.element.inMemoryOnly}">
        <div class="row"><div class="alert">New Glide configuration - Please reload the page.</div></div>
    </c:when>
    <c:when test="${cms.edited}">
        <div class="row"><div class="alert">Glide configuration changed - Please reload the page.</div></div>
    </c:when>
    <c:otherwise>

<c:set var="valueMap" value="${content.value}" />
<% 
Map<String,CmsJspContentAccessValueWrapper> valueMap=(Map<String,CmsJspContentAccessValueWrapper>) pageContext.getAttribute("valueMap");
if (isGlideUser(request, valueMap)) { // only the authorized group can see and use Glide
	CmsObject cmsObj=org.opencms.flex.CmsFlexController.getCmsObject(request);
	if (!cmsObj.getRequestContext().getCurrentProject().isOnlineProject()) { // we show the panel only offline
	//if (PARAM_GRUNT_START.equals(request.getParameter(PARAM_GRUNT_NAME))) gruntStart(request, valueMap);
	//else if (PARAM_GRUNT_STOP.equals(request.getParameter(PARAM_GRUNT_NAME))) gruntStop(request);
	autoPublish(valueMap.get("ModuleName").toString(), pageContext, request, response);
%>
<div class="glide-panel">
	<%@include file="../elements/glide-scripts.jsp"%>
	<div class="open-panel">
	  <i class="glide-icon-cog-alt"></i>
	</div>
	<h3>${content.value.Title}</h3>
	<div class="layout-mode">
		<i class="glide-icon-resize-horizontal"></i>
		<i class="glide-icon-resize-vertical"></i>
	</div>
	<div id="log" class="grunt-log">(log)</div>
	<div class="actions">
		<form id="gruntRunnerForm" method="post" action="<cms:link>/system/modules/it.teamquality.glide/elements/grunt-runner.jsp</cms:link>">
		   	<input type="hidden" name="moduleName" value="${content.value.ModuleName}"/>
				<input type="hidden" name="outputStyle" value="${content.value.OutputStyle}"/>
				<input type="hidden" name="environment" value="${content.value.Environment}"/>
				<input type="hidden" name="mountPath" value="${content.value.MountPath}"/>
				<input type="hidden" name="reloadPort" value="${content.value.ReloadPort}"/>
				<input type="hidden" name="<%=PARAM_GRUNT_NAME%>" value=""/>
				<button class="start" onclick="return runnerFormSubmit('<%=PARAM_GRUNT_START%>')" type="submit">
					<i class="glide-icon-check"></i> Start <i id="glide-loading" class="icon-spinner icon-spin"></i>
				</button>
				<button class="stop" onclick="return runnerFormSubmit('<%=PARAM_GRUNT_STOP%>')" type="submit"><i class="glide-icon-cancel"></i> Stop</button>
		</form> 
	</div>

	<hr/>
	<div class="switches">
		<div>
			<span>Live reload</span>
			<input type="checkbox" class="toggle" id="set<%=COOKIE_LIVE_RELOAD%>">
			<label for="set<%=COOKIE_LIVE_RELOAD%>">&nbsp;</label>
		</div>
		<div>
			<span>Auto publish</span>
			<input type="checkbox" class="toggle" id="set<%=COOKIE_AUTO_PUBLISH%>">
			<label for="set<%=COOKIE_AUTO_PUBLISH%>">&nbsp;</label>
		</div>
		<div>
			<span>Stay open</span>
			<input type="checkbox" class="toggle" id="set<%=COOKIE_STAY_OPEN%>">
			<label for="set<%=COOKIE_STAY_OPEN%>">&nbsp;</label>
		</div>
	</div>
</div><!-- end glide-panel -->
	<% } else { // online project %>
		<div><!-- glide user always autoreload online -->
			<script type="text/javascript">
				jQuery.getScript("http://${pageContext.request.serverName}:${content.value.ReloadPort}/livereload.js", function( data, textStatus, jqxhr ) {
					//var originalFunction=window.LiveReload.performReload;
					window.LiveReload.performReload = function(message) {
						console.log("delayed reload");
						setTimeout(function(){location.reload();},3000); // give it time to end publishing
					};
				});
			</script>
		</div>
	<% } %>
<% } else { // !(isGlideUser(request, valueMap) %>
<div><!-- User not authorized to use Glide --></div>
<% } %>

	</c:otherwise>
</c:choose>

</cms:formatter>