<%@page buffer="none" session="false" taglibs="c,cms,fmt,fn" trimDirectiveWhitespaces="true" import="org.opencms.file.*" %>
<jsp:useBean id="login" class="org.opencms.jsp.CmsJspLoginBean" scope="page">
	<% login.init (pageContext, request, response); %>
	<c:if test="${param.action eq 'login' && !empty param.name && !empty param.password}">
		<% login.login(request.getParameter("name"), request.getParameter("password"), CmsProject.ONLINE_PROJECT_NAME); %>
	</c:if>
	<c:if test="${param.action eq 'logout'}">
		<% login.logout(); %>
	</c:if>
</jsp:useBean>

<div>
<c:choose>
	<c:when test="${!login.loggedIn}">
		<div class="boxNotLogged">
			<h2>Login to ${pageContext.request.serverName}</h2> 
			<form method="get" action="<cms:link>${cms.requestContext.uri}</cms:link>" class="loginform">
				<div class="boxform">
					<label for="name">Username:</label>
					<input type="text" name="name" value="glide">
				</div>
				<div class="boxform">
					<label for="password">Password:</label>
					<input type="password" name="password" value="demo">
				</div>
				<div class="boxform">
					<input type="hidden" name="action" value="login" />
					<input class="button" type="submit" value="Login"/>
				</div>
			</form>
		</div>
	</c:when>
	<c:otherwise>
		<div class="boxLogged">
			<p>
				<strong>User logged in: </strong>
				<c:set var="firstname"><cms:user property="firstname"/></c:set>
				<c:set var="lastname"><cms:user property="lastname"/></c:set>
				<c:if test="${not empty firstname}">${firstname}&nbsp;</c:if><c:if test="${not empty lastname}">${lastname}</c:if>
				<c:set var="username"><cms:user property="name"/></c:set>
				<c:if test="${empty firstname && empty lastname}">
					<c:if test="${fn:indexOf(username, '/') != -1}">
						<c:set var="username">${fn:substringAfter(username, '/')}</c:set>
					</c:if>
					(${username})
				</c:if>
			</p>
			<a href="?action=logout">Logout</a>
		</div>
	</c:otherwise>
</c:choose>
</div>
